/**
 *  Copyright (c) 2019 CentraleSupélec & EDF.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the RiseClipse tool
 *  
 *  Contributors:
 *      Computer Science Department, CentraleSupélec
 *      EDF R&D
 *  Contacts:
 *      dominique.marcadet@centralesupelec.fr
 *      aurelie.dehouck-neveu@edf.fr
 *  Web site:
 *      http://wdi.supelec.fr/software/RiseClipse/
 * 
 */
package fr.centralesupelec.edf.riseclipse.iec61850.nsd.provider;

import fr.centralesupelec.edf.riseclipse.iec61850.nsd.util.NsdAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class NsdItemProviderAdapterFactory extends NsdAdapterFactory
        implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Collection< Object > supportedTypes = new ArrayList< Object >();

    /**
     * This constructs an instance.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NsdItemProviderAdapterFactory() {
        supportedTypes.add( IEditingDomainItemProvider.class );
        supportedTypes.add( IStructuredItemContentProvider.class );
        supportedTypes.add( ITreeItemContentProvider.class );
        supportedTypes.add( IItemLabelProvider.class );
        supportedTypes.add( IItemPropertySource.class );
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.AppliesToType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AppliesToTypeItemProvider appliesToTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.AppliesToType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAppliesToTypeAdapter() {
        if( appliesToTypeItemProvider == null ) {
            appliesToTypeItemProvider = new AppliesToTypeItemProvider( this );
        }

        return appliesToTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DependsOn} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DependsOnItemProvider dependsOnItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DependsOn}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDependsOnAdapter() {
        if( dependsOnItemProvider == null ) {
            dependsOnItemProvider = new DependsOnItemProvider( this );
        }

        return dependsOnItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DocumentRoot} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DocumentRootItemProvider documentRootItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DocumentRoot}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDocumentRootAdapter() {
        if( documentRootItemProvider == null ) {
            documentRootItemProvider = new DocumentRootItemProvider( this );
        }

        return documentRootItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceTypeItemProvider serviceTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceTypeAdapter() {
        if( serviceTypeItemProvider == null ) {
            serviceTypeItemProvider = new ServiceTypeItemProvider( this );
        }

        return serviceTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Abbreviation} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbbreviationItemProvider abbreviationItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Abbreviation}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAbbreviationAdapter() {
        if( abbreviationItemProvider == null ) {
            abbreviationItemProvider = new AbbreviationItemProvider( this );
        }

        return abbreviationItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Abbreviations} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AbbreviationsItemProvider abbreviationsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Abbreviations}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAbbreviationsAdapter() {
        if( abbreviationsItemProvider == null ) {
            abbreviationsItemProvider = new AbbreviationsItemProvider( this );
        }

        return abbreviationsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ApplicableServiceNS} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ApplicableServiceNSItemProvider applicableServiceNSItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ApplicableServiceNS}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createApplicableServiceNSAdapter() {
        if( applicableServiceNSItemProvider == null ) {
            applicableServiceNSItemProvider = new ApplicableServiceNSItemProvider( this );
        }

        return applicableServiceNSItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ApplicableServices} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ApplicableServicesItemProvider applicableServicesItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ApplicableServices}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createApplicableServicesAdapter() {
        if( applicableServicesItemProvider == null ) {
            applicableServicesItemProvider = new ApplicableServicesItemProvider( this );
        }

        return applicableServicesItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.BasicType} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BasicTypeItemProvider basicTypeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.BasicType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBasicTypeAdapter() {
        if( basicTypeItemProvider == null ) {
            basicTypeItemProvider = new BasicTypeItemProvider( this );
        }

        return basicTypeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.BasicTypes} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected BasicTypesItemProvider basicTypesItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.BasicTypes}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createBasicTypesAdapter() {
        if( basicTypesItemProvider == null ) {
            basicTypesItemProvider = new BasicTypesItemProvider( this );
        }

        return basicTypesItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.CDC} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CDCItemProvider cdcItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.CDC}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCDCAdapter() {
        if( cdcItemProvider == null ) {
            cdcItemProvider = new CDCItemProvider( this );
        }

        return cdcItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.CDCs} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CDCsItemProvider cdCsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.CDCs}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCDCsAdapter() {
        if( cdCsItemProvider == null ) {
            cdCsItemProvider = new CDCsItemProvider( this );
        }

        return cdCsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Changes} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ChangesItemProvider changesItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Changes}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createChangesAdapter() {
        if( changesItemProvider == null ) {
            changesItemProvider = new ChangesItemProvider( this );
        }

        return changesItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ConstructedAttribute} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConstructedAttributeItemProvider constructedAttributeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ConstructedAttribute}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConstructedAttributeAdapter() {
        if( constructedAttributeItemProvider == null ) {
            constructedAttributeItemProvider = new ConstructedAttributeItemProvider( this );
        }

        return constructedAttributeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ConstructedAttributes} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ConstructedAttributesItemProvider constructedAttributesItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ConstructedAttributes}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createConstructedAttributesAdapter() {
        if( constructedAttributesItemProvider == null ) {
            constructedAttributesItemProvider = new ConstructedAttributesItemProvider( this );
        }

        return constructedAttributesItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Copyrighted} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CopyrightedItemProvider copyrightedItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Copyrighted}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCopyrightedAdapter() {
        if( copyrightedItemProvider == null ) {
            copyrightedItemProvider = new CopyrightedItemProvider( this );
        }

        return copyrightedItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.CopyrightNotice} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected CopyrightNoticeItemProvider copyrightNoticeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.CopyrightNotice}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createCopyrightNoticeAdapter() {
        if( copyrightNoticeItemProvider == null ) {
            copyrightNoticeItemProvider = new CopyrightNoticeItemProvider( this );
        }

        return copyrightNoticeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DataAttribute} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DataAttributeItemProvider dataAttributeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DataAttribute}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDataAttributeAdapter() {
        if( dataAttributeItemProvider == null ) {
            dataAttributeItemProvider = new DataAttributeItemProvider( this );
        }

        return dataAttributeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DataObject} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DataObjectItemProvider dataObjectItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DataObject}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDataObjectAdapter() {
        if( dataObjectItemProvider == null ) {
            dataObjectItemProvider = new DataObjectItemProvider( this );
        }

        return dataObjectItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DataSetMemberOf} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DataSetMemberOfItemProvider dataSetMemberOfItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.DataSetMemberOf}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDataSetMemberOfAdapter() {
        if( dataSetMemberOfItemProvider == null ) {
            dataSetMemberOfItemProvider = new DataSetMemberOfItemProvider( this );
        }

        return dataSetMemberOfItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Doc} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected DocItemProvider docItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Doc}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createDocAdapter() {
        if( docItemProvider == null ) {
            docItemProvider = new DocItemProvider( this );
        }

        return docItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Enumeration} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EnumerationItemProvider enumerationItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Enumeration}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEnumerationAdapter() {
        if( enumerationItemProvider == null ) {
            enumerationItemProvider = new EnumerationItemProvider( this );
        }

        return enumerationItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Enumerations} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected EnumerationsItemProvider enumerationsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Enumerations}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createEnumerationsAdapter() {
        if( enumerationsItemProvider == null ) {
            enumerationsItemProvider = new EnumerationsItemProvider( this );
        }

        return enumerationsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.FunctionalConstraint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FunctionalConstraintItemProvider functionalConstraintItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.FunctionalConstraint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFunctionalConstraintAdapter() {
        if( functionalConstraintItemProvider == null ) {
            functionalConstraintItemProvider = new FunctionalConstraintItemProvider( this );
        }

        return functionalConstraintItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.FunctionalConstraints} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected FunctionalConstraintsItemProvider functionalConstraintsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.FunctionalConstraints}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createFunctionalConstraintsAdapter() {
        if( functionalConstraintsItemProvider == null ) {
            functionalConstraintsItemProvider = new FunctionalConstraintsItemProvider( this );
        }

        return functionalConstraintsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.License} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LicenseItemProvider licenseItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.License}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLicenseAdapter() {
        if( licenseItemProvider == null ) {
            licenseItemProvider = new LicenseItemProvider( this );
        }

        return licenseItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Literal} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LiteralItemProvider literalItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Literal}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLiteralAdapter() {
        if( literalItemProvider == null ) {
            literalItemProvider = new LiteralItemProvider( this );
        }

        return literalItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.LNClass} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LNClassItemProvider lnClassItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.LNClass}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLNClassAdapter() {
        if( lnClassItemProvider == null ) {
            lnClassItemProvider = new LNClassItemProvider( this );
        }

        return lnClassItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.LNClasses} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected LNClassesItemProvider lnClassesItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.LNClasses}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createLNClassesAdapter() {
        if( lnClassesItemProvider == null ) {
            lnClassesItemProvider = new LNClassesItemProvider( this );
        }

        return lnClassesItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Notice} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NoticeItemProvider noticeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.Notice}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNoticeAdapter() {
        if( noticeItemProvider == null ) {
            noticeItemProvider = new NoticeItemProvider( this );
        }

        return noticeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.NS} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NSItemProvider nsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.NS}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNSAdapter() {
        if( nsItemProvider == null ) {
            nsItemProvider = new NSItemProvider( this );
        }

        return nsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.NSDoc} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected NSDocItemProvider nsDocItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.NSDoc}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createNSDocAdapter() {
        if( nsDocItemProvider == null ) {
            nsDocItemProvider = new NSDocItemProvider( this );
        }

        return nsDocItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.PresenceCondition} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PresenceConditionItemProvider presenceConditionItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.PresenceCondition}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPresenceConditionAdapter() {
        if( presenceConditionItemProvider == null ) {
            presenceConditionItemProvider = new PresenceConditionItemProvider( this );
        }

        return presenceConditionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.PresenceConditions} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PresenceConditionsItemProvider presenceConditionsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.PresenceConditions}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPresenceConditionsAdapter() {
        if( presenceConditionsItemProvider == null ) {
            presenceConditionsItemProvider = new PresenceConditionsItemProvider( this );
        }

        return presenceConditionsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceCDC} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceCDCItemProvider serviceCDCItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceCDC}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceCDCAdapter() {
        if( serviceCDCItemProvider == null ) {
            serviceCDCItemProvider = new ServiceCDCItemProvider( this );
        }

        return serviceCDCItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceCDCs} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceCDCsItemProvider serviceCDCsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceCDCs}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceCDCsAdapter() {
        if( serviceCDCsItemProvider == null ) {
            serviceCDCsItemProvider = new ServiceCDCsItemProvider( this );
        }

        return serviceCDCsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceConstructedAttribute} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceConstructedAttributeItemProvider serviceConstructedAttributeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceConstructedAttribute}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceConstructedAttributeAdapter() {
        if( serviceConstructedAttributeItemProvider == null ) {
            serviceConstructedAttributeItemProvider = new ServiceConstructedAttributeItemProvider( this );
        }

        return serviceConstructedAttributeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceConstructedAttributes} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceConstructedAttributesItemProvider serviceConstructedAttributesItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceConstructedAttributes}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceConstructedAttributesAdapter() {
        if( serviceConstructedAttributesItemProvider == null ) {
            serviceConstructedAttributesItemProvider = new ServiceConstructedAttributesItemProvider( this );
        }

        return serviceConstructedAttributesItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceDataAttribute} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceDataAttributeItemProvider serviceDataAttributeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceDataAttribute}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceDataAttributeAdapter() {
        if( serviceDataAttributeItemProvider == null ) {
            serviceDataAttributeItemProvider = new ServiceDataAttributeItemProvider( this );
        }

        return serviceDataAttributeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceNS} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceNSItemProvider serviceNSItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceNS}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceNSAdapter() {
        if( serviceNSItemProvider == null ) {
            serviceNSItemProvider = new ServiceNSItemProvider( this );
        }

        return serviceNSItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceNsUsage} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceNsUsageItemProvider serviceNsUsageItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceNsUsage}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceNsUsageAdapter() {
        if( serviceNsUsageItemProvider == null ) {
            serviceNsUsageItemProvider = new ServiceNsUsageItemProvider( this );
        }

        return serviceNsUsageItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceParameter} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceParameterItemProvider serviceParameterItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceParameter}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceParameterAdapter() {
        if( serviceParameterItemProvider == null ) {
            serviceParameterItemProvider = new ServiceParameterItemProvider( this );
        }

        return serviceParameterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceTypeRealizations} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ServiceTypeRealizationsItemProvider serviceTypeRealizationsItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.ServiceTypeRealizations}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createServiceTypeRealizationsAdapter() {
        if( serviceTypeRealizationsItemProvider == null ) {
            serviceTypeRealizationsItemProvider = new ServiceTypeRealizationsItemProvider( this );
        }

        return serviceTypeRealizationsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.SubDataAttribute} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SubDataAttributeItemProvider subDataAttributeItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.SubDataAttribute}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSubDataAttributeAdapter() {
        if( subDataAttributeItemProvider == null ) {
            subDataAttributeItemProvider = new SubDataAttributeItemProvider( this );
        }

        return subDataAttributeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.SubDataObject} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SubDataObjectItemProvider subDataObjectItemProvider;

    /**
     * This creates an adapter for a {@link fr.centralesupelec.edf.riseclipse.iec61850.nsd.SubDataObject}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSubDataObjectAdapter() {
        if( subDataObjectItemProvider == null ) {
            subDataObjectItemProvider = new SubDataObjectItemProvider( this );
        }

        return subDataObjectItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ComposeableAdapterFactory getRootAdapterFactory() {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void setParentAdapterFactory( ComposedAdapterFactory parentAdapterFactory ) {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean isFactoryForType( Object type ) {
        return supportedTypes.contains( type ) || super.isFactoryForType( type );
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter adapt( Notifier notifier, Object type ) {
        return super.adapt( notifier, this );
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object adapt( Object object, Object type ) {
        if( isFactoryForType( type ) ) {
            Object adapter = super.adapt( object, type );
            if( !( type instanceof Class< ? > ) || ( ( ( Class< ? > ) type ).isInstance( adapter ) ) ) {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void addListener( INotifyChangedListener notifyChangedListener ) {
        changeNotifier.addListener( notifyChangedListener );
    }

    /**
     * This removes a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void removeListener( INotifyChangedListener notifyChangedListener ) {
        changeNotifier.removeListener( notifyChangedListener );
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void fireNotifyChanged( Notification notification ) {
        changeNotifier.fireNotifyChanged( notification );

        if( parentAdapterFactory != null ) {
            parentAdapterFactory.fireNotifyChanged( notification );
        }
    }

    /**
     * This disposes all of the item providers created by this factory. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void dispose() {
        if( appliesToTypeItemProvider != null ) appliesToTypeItemProvider.dispose();
        if( dependsOnItemProvider != null ) dependsOnItemProvider.dispose();
        if( documentRootItemProvider != null ) documentRootItemProvider.dispose();
        if( serviceTypeItemProvider != null ) serviceTypeItemProvider.dispose();
        if( abbreviationItemProvider != null ) abbreviationItemProvider.dispose();
        if( abbreviationsItemProvider != null ) abbreviationsItemProvider.dispose();
        if( applicableServiceNSItemProvider != null ) applicableServiceNSItemProvider.dispose();
        if( applicableServicesItemProvider != null ) applicableServicesItemProvider.dispose();
        if( basicTypeItemProvider != null ) basicTypeItemProvider.dispose();
        if( basicTypesItemProvider != null ) basicTypesItemProvider.dispose();
        if( cdcItemProvider != null ) cdcItemProvider.dispose();
        if( cdCsItemProvider != null ) cdCsItemProvider.dispose();
        if( changesItemProvider != null ) changesItemProvider.dispose();
        if( constructedAttributeItemProvider != null ) constructedAttributeItemProvider.dispose();
        if( constructedAttributesItemProvider != null ) constructedAttributesItemProvider.dispose();
        if( copyrightedItemProvider != null ) copyrightedItemProvider.dispose();
        if( copyrightNoticeItemProvider != null ) copyrightNoticeItemProvider.dispose();
        if( dataAttributeItemProvider != null ) dataAttributeItemProvider.dispose();
        if( dataObjectItemProvider != null ) dataObjectItemProvider.dispose();
        if( dataSetMemberOfItemProvider != null ) dataSetMemberOfItemProvider.dispose();
        if( docItemProvider != null ) docItemProvider.dispose();
        if( enumerationItemProvider != null ) enumerationItemProvider.dispose();
        if( enumerationsItemProvider != null ) enumerationsItemProvider.dispose();
        if( functionalConstraintItemProvider != null ) functionalConstraintItemProvider.dispose();
        if( functionalConstraintsItemProvider != null ) functionalConstraintsItemProvider.dispose();
        if( licenseItemProvider != null ) licenseItemProvider.dispose();
        if( literalItemProvider != null ) literalItemProvider.dispose();
        if( lnClassItemProvider != null ) lnClassItemProvider.dispose();
        if( lnClassesItemProvider != null ) lnClassesItemProvider.dispose();
        if( noticeItemProvider != null ) noticeItemProvider.dispose();
        if( nsItemProvider != null ) nsItemProvider.dispose();
        if( nsDocItemProvider != null ) nsDocItemProvider.dispose();
        if( presenceConditionItemProvider != null ) presenceConditionItemProvider.dispose();
        if( presenceConditionsItemProvider != null ) presenceConditionsItemProvider.dispose();
        if( serviceCDCItemProvider != null ) serviceCDCItemProvider.dispose();
        if( serviceCDCsItemProvider != null ) serviceCDCsItemProvider.dispose();
        if( serviceConstructedAttributeItemProvider != null ) serviceConstructedAttributeItemProvider.dispose();
        if( serviceConstructedAttributesItemProvider != null ) serviceConstructedAttributesItemProvider.dispose();
        if( serviceDataAttributeItemProvider != null ) serviceDataAttributeItemProvider.dispose();
        if( serviceNSItemProvider != null ) serviceNSItemProvider.dispose();
        if( serviceNsUsageItemProvider != null ) serviceNsUsageItemProvider.dispose();
        if( serviceParameterItemProvider != null ) serviceParameterItemProvider.dispose();
        if( serviceTypeRealizationsItemProvider != null ) serviceTypeRealizationsItemProvider.dispose();
        if( subDataAttributeItemProvider != null ) subDataAttributeItemProvider.dispose();
        if( subDataObjectItemProvider != null ) subDataObjectItemProvider.dispose();
    }

}
